package de.ids_mannheim.korap.openthesaurus;

/* Experiments:
InputStream in = Test.class.getResourceAsStream("/test.txt");
int remainingSize = in.available();
while (remainingSize > 0 ) {
    System.out.println("Remaining bytes to read in: " + remainingSize);
    int size = in.available() >= 512 ? 512 : remainingSize;
    byte b[] = new byte[size];
    if (in.read(b) !=-1) {
        System.out.println(Arrays.toString(b)); // new String(b)
    }
    remainingSize = in.available();
}
 */

/*
BufferedReader bf = new BufferedReader(
        new InputStreamReader(Test.class.getResourceAsStream("/test.txt")));
bf.lines().forEach(System.out::println);

*/

import java.util.*;
import java.util.Map.Entry;
import java.util.stream.Collectors;


public class Experiments {

    interface Method {
        int method();
    }

    public static void main(String[] args) {
        // This example shows that Collections (e.g. ArrayLists) are mutable
        HashMap<String, List<String>> hashMap = new HashMap<>();
        List<String> players = new ArrayList<>();
        players.add("Player1");
        players.add("Player2");
        hashMap.put("Team1", players);
        List<String> players2 = new ArrayList<>();
        players2.add("Player1");
        players2.add("Player2");
        hashMap.put("Team2", players2);
        //System.out.println(hashMap);

        HashMap<String, List<String>> hashMap1 = new HashMap<>();
        List<String> players1 = new ArrayList<>();
        players1.add("Player3");
        players1.add("Player4");
        players1.add("Player5");
        hashMap1.put("Team1", players1);
        //System.out.println(hashMap1);

        List<HashMap<String, List<String>>> teamsList = new ArrayList<>();
        teamsList.add(hashMap);
        teamsList.add(hashMap1);

        System.out.println(teamsList);
        /*
        HashMap<String, List<List<String>>> merged = new HashMap<>();

        for (HashMap<String, List<String>> teams : teamsList) {
            Iterator<Entry<String, List<String>>> it = teams.entrySet().iterator();
            while (it.hasNext()) {
                Map.Entry<String, List<String>> pair = it.next();
                String word = pair.getKey();
                List<String> synonyms = pair.getValue();

                if (merged.containsKey(word)) {
                    merged.get(word).add(synonyms);
                } else {
                    List<List<String>> synsetList = new ArrayList<>();
                    synsetList.add(synonyms);
                    merged.put(word, synsetList);
                }
                ;
                it.remove(); // avoids a ConcurrentModificationException
            }
        }
        System.out.println(merged);

         */

        Map<String, List<List<String>>> teamsDict = teamsList
                .stream()
                .flatMap(m -> m.entrySet().stream())
                .collect(Collectors.groupingBy(Map.Entry::getKey,
                         Collectors.mapping(Map.Entry::getValue, Collectors.toList())));

        System.out.println(teamsDict);

    }
}
